<template>
  <section>
    <ResultsIntra
      v-if="config.configType == 'intra'"
      :results="results"
      :config="config"
      :transparency-html="transparencyHtml"
      :transparency-data="transparencyData"
    />

    <ResultsInter
      v-else
      :results="results"
      :config="config"
      :transparency-html="transparencyHtml"
      :transparency-data="transparencyData"
    />
  </section>
</template>

<style lang="postcss" scoped>
.vgt-table thead th {
  vertical-align: middle;
}

.absolute-center-vertical {
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
}

.alternate-background:nth-child(odd):not(:hover) {
  @apply bg-grey-lighter;
}

.table {
  td {
    @apply border p-2;
  }
}
</style>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import ResultsInter from '@/views/ResultsInter.vue'
import ResultsIntra from '@/views/ResultsIntra.vue'

import _ from 'lodash/fp'
import axios from 'axios'

@Component({
  components: {
    ResultsInter,
    ResultsIntra
  }
})
export default class Results extends Vue {
  @State userID
  @State jobID

  config : any = {}
  results: any[] = []
  transparencyData: any = {}
  transparencyHtml: string = ''

  created () {
    this.getResults()
  }

  getResults () {
    axios.get('/api/results', {
      params: {
        userID: this.userID,
        jobID: this.jobID
      }
    }).then(({
      data
    }) => {
      this.config = data.whatWasUsed
      this.transparencyData = { ...data.transparencyData, results: data.results }
      this.transparencyHtml = data.transparencyHtml

      if (data.sentences) {
        const resultsWithSentences = _.zip(data.results, data.sentences) as unknown as any[][]

        this.results = _.map(
          ([result, sentence]) => ({ ...result, sentence }),
          resultsWithSentences
        )
      } else {
        this.results = data.results
      }
    }).catch((e) => {
      console.error(e)
      this.$router.push('/')
    })
  }
}
</script>
